function [P,E,GammaD,GammaN] = diskretizace(a,b,h)

% [P,E,GammaD,GammaN] = diskretizace(a,b,h)
%       Diskretizuje obdelnik <0,a> x <0,b> s krokem h.
%       P ... souradnice uzlu trojuhelnikove site
%       E ... trojice uzlu
%       GammaD ... souradnice uzlu na Dirichletove hranici dole, vlevo a vpravo
%       GammaN ... souradnice dvojic uzlu na Neumannove hranici nahore

m1 = ceil(a/h);
h1 = a/m1;
m2 = ceil(b/h);
h2 = b/m2;

n = (m1+1)*(m2+1);
P = zeros(2,n);

m = 2*m1*m2;
E = zeros(3,m);

GammaD = [];
GammaN = [];

idxP = 1;
idxE = 1;
for i=0:m1
    x1 = i*h1;
    for j=0:m2
        x2 = j*h2;
        P(:,idxP) = [x1;x2];
        
        if i<m1 && j<m2
            E(:,idxE) = [idxP;idxP+m2+1;idxP+m2+2];
            E(:,idxE+1) = [idxP;idxP+m2+2;idxP+1];
            idxE = idxE+2;
        end
        
        if j==0 || i==0 || i==m1
            GammaD = [ GammaD , idxP ];
        end
        
        if j==m2 && i<m1
            GammaN = [ GammaN , [idxP;idxP+m2+1] ];
        end
        
        idxP = idxP+1;
    end
end
